#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/commands/mobu.c,v 2.2 1995/10/11 03:02:33 empire Exp $";
#endif /* not lint */

/*
 * mobu.c
 *
 * adjust mobility updating
 *
 * Steve McClure, 1996
 */

#include "misc.h"
#include "player.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "nsc.h"
#include "nat.h"
#include "deity.h"
#include "path.h"
#include "file.h"

#include <stdio.h>

#ifdef MOB_ACCESS

mobupdate()
{
        FILE    *fp;
	long    minites;
	extern  int updating_mob;
	struct  mob_acc_globals timestamps;
	long    now;
	extern  s_char *timestampfil;

	if (!player->argp[1])
	  return RET_SYN;
	if (*player->argp[1] == 'c')
	  minites = -1;
	else
	  minites = atol(player->argp[1]) * 60;
	time(&now);
	if ((fp = fopen(timestampfil, "r+")) == NULL) {
	  logerror("Unable to edit timestamp file.");
	} else {
	  rewind(fp);
	  fread(&timestamps, sizeof(timestamps), 1, fp);
	  if (minites < 0) {
	    fclose(fp);
	    if (updating_mob)
	      pr("Mobility updating is on.");
	    else {
	      pr("Mobility updating will come back on around %s",
		 ctime(&timestamps.starttime));
	      pr("within 3 minutes, depending on when the server checks.");
	    }
	    return 0;
	  }
	  timestamps.timestamp = now;
	  timestamps.starttime = now + minites;
	  rewind(fp);
	  fwrite(&timestamps, sizeof(timestamps), 1, fp);
	  fclose(fp);
	  if (now >= timestamps.starttime) {
	    pr("Turning on mobility updating.");
	    update_all_mob();
	    updating_mob = 1;
	  } else if (updating_mob == 1) {
	    pr("Turning off mobility updating.\n\r");
	    pr("Mobility updating will come back on around %s",
	       ctime(&timestamps.starttime));
	    pr("within 3 minutes, depending on when the server checks.");
	    update_all_mob();
	    updating_mob = 0;
	  } else if (updating_mob == 0) {
	    pr("Mobility updating is already off.\n\r");
	    pr("Mobility updating will come back on around %s",
	       ctime(&timestamps.starttime));
	    pr("within 3 minutes, depending on when the server checks.");
	  }
	}
	
	return 0;
}

#endif MOB_ACCESS
